<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - File Set Entries</TITLE>
<link href="suif1_10.html" rel=Next>
<link href="suif1_8.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_8.html">previous</A>, <A HREF="suif1_10.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC9" HREF="suif1_toc.html#TOC9">File Set Entries</A></H2>
<P>
<A NAME="IDX13"></A>

</P>
<P>
<A NAME="IDX14"></A>
<A NAME="IDX15"></A>
<A NAME="IDX16"></A>
<A NAME="IDX17"></A>
File set entries are implemented by the <CODE>file_set_entry</CODE> class.
The <CODE>file_set_entry_list</CODE> class is also defined to hold the file
set entries in the file set.  A file set entry records the input and
output streams for a source file.  Either the input or output streams
could be empty.  The <CODE>name</CODE> method returns the name of the input
file, if it exists.  Otherwise it returns the name of the output file.
The <CODE>parent</CODE> method returns the file set which contains the file
set entry.

</P>
<P>
<A NAME="IDX18"></A>
The file set entry also contains the file symbol table.  See section <A HREF="suif1_43.html#SEC43">File Symbol Tables</A>.  The file symbol table holds the symbols and types
declared within the scope of the file.  This includes variables and
functions declared with static linkage and types that are only visible
within the file.  The file symbol table is accessed using the
<CODE>symtab</CODE> method.

</P>
<P>
<A NAME="IDX19"></A>
<A NAME="IDX20"></A>
The file set entry class provides an iterator to visit all of the
procedures that are defined in the input file.  Note that this does not
include procedures that are declared but whose bodies are defined
elsewhere.  The <CODE>reset_proc_iter</CODE> method resets the iterator to the
first procedure.  The <CODE>next_proc</CODE> method returns the next procedure
in the input file.

</P>
<P>
The following code reads each procedure in the given file set entry,
calls the function <CODE>process_proc</CODE> on the procedure, and then writes
it out.

</P>

<PRE>
void process_file (file_set_entry *fse)
{
    proc_sym *psym;

    fse-&#62;reset_proc_iter();
    while (psym = fse-&#62;next_proc()) {
        psym-&#62;read_proc();

        process_procedure(psym);

        psym-&#62;write_proc(fse);
        psym-&#62;flush_proc();
    }
}
</PRE>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_8.html">previous</A>, <A HREF="suif1_10.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
